﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using System.IO;
using System.Net;

namespace TeamDemo
{
    class Program
    {
        /// <summary>
        /// 接口API地址
        /// </summary>
        public const string api = "http://api.storagesdk.com/";

        /// <summary>
        /// 接口方法
        /// </summary>
        public const string getTokenMethod = "restful/storageapi/storage/getToken"; // 获取操作密钥token
        public const string uploadFileMethod = "restful/storageapi/file/uploadFile"; // 上传文件
        public const string getFileUrlMethod = "restful/storageapi/file/getFileUrl"; // 获取文件访问链接
        public const string delFileMethod = "restful/storageapi/file/deleteFile"; // 删除文件
        public const string createFolderMethod = "restful/storageapi/folder/createFolder";// 创建文件夹
        public const string deleteFolderMethod = "restful/storageapi/folder/deleteFolder"; // 删除文件夹
        public const string getsSubFolderAndFilesMethod = "restful/storageapi/folder/getSubFoldersAndFiles"; // 获取当前目录下子目录及其文件
        public const string renameFolderMethod = "restful/storageapi/folder/renameFolder"; // 重命名文件夹
        public const string renameFileMethod = "restful/storageapi/file/renameFile"; // 重命名文件
        public const string copyFileMethod = "restful/storageapi/file/copyFile"; // 复制文件
        public const string copyFolderMethod = "restful/storageapi/folder/copyFolder"; // 复制文件夹

        /// <summary>
        /// 参数说明
        /// </summary>
        public const string accessKey = "I1I7CLU4708LI8XQ0ODL"; // 用户秘钥对：开通快云存储时的Access_Key，可在会员中心获取S
        public const string secretKey = "N41hrYy14gI03RpnZijfezGl/VUtZP3b77vjF6nn"; // 用户秘钥对：开通快云存储时的Secret_Key，可在会员中心获取
        public const string resource = "VG3OQ81wtrNGANeuq8IdwWxGFK0xdA3X"; // API调用来源，可在会员中心点击获取
        public const string voucher = "dcb99d196dd2418ec1fdfa7269ee4b81";  // 凭证, 用户通过accesskey和secretkey获取的，可在会员中心点击，以邮件形式获取
        //
        public static string token = ""; // 用户操作秘钥，是用户调用api接口时必须用到的的秘钥；可以通过API获取

        /// <summary>
        /// demo测试
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            // 获取操作密钥token
            token = getToken();
            Console.WriteLine("获取token的返回结果:" + token);

            // 测试空间名称，已经创建的空间名
            string bucketName = "demobkt"; // 用户的空间名称

            // 上传文件
		    string localFile = "C:\\demo.png"; // 本地图片路径
		    string fileName = "demo.png"; // 上传到对象存储中文件路径名；如果是多级的，自动创建文件夹，例folder/demo.png，自动创建folder目录，并在该目录下上传demo.png文件
            String resultInfo = uploadFile(bucketName, localFile, fileName);
            Console.WriteLine("上传文件返回结果:" + resultInfo);

            // 获取文件访问链接
		    int minutes = 0; // 获取链接时效,可不传；默认是0，无时效，即永久有效。
		    String objectUrlInfo = getFileUrl(bucketName, fileName, minutes);
            Console.WriteLine("获取文件访问链接的返回结果:" + objectUrlInfo);

            // 删除文件
            resultInfo = delFile(bucketName, fileName);
            Console.WriteLine("删除文件的返回结果:" + resultInfo);
            
            //创建文件夹
		    string fileFolder = "demofd0"; // 文件夹已经存在，创建失败
            resultInfo = createFolder(bucketName, fileFolder);
            Console.WriteLine("创建文件夹的返回结果" + resultInfo);
		    	
		    // 删除文件夹
            resultInfo = delFolder(bucketName, fileFolder);
            Console.WriteLine("删除文件夹的返回结果" + resultInfo);

            // 获取当前文件目录下子目录列表及文件列表
		    string folderName = "demofd"; // 文件目录名
		    Boolean isGetFile = true; // 是否获取文件[true.是,false.否]
		    resultInfo = getSubFoldersAndFiles(bucketName, folderName, isGetFile);
            Console.WriteLine("获取当前目录下子目录及文件的返回结果" + resultInfo);

            // 重命名文件
		    String oldFileName = "demofd/000000.png"; // 原文件名称，已经存在的文件名
		    String newFileName = "demofd/111111.png"; // 新文件名称，如果已经有此文件存在，重命名失败
		    resultInfo = renameFile(bucketName, oldFileName, newFileName);
		    Console.WriteLine("重命名文件的返回结果" + resultInfo);

		    // 重命名文件夹
            string oldFolderName = "demofd/folder1"; // 原文件夹名称，已经存在的目录文件夹（根目录，即空间目录不能修改）
            string newFolderName = "demofd/folder2"; // 新文件夹名称，如果已经有此文件夹存在，重命名失败
		    resultInfo = renameFolder(bucketName, oldFolderName, newFolderName);
		    Console.WriteLine("重命名文件夹的返回结果" + resultInfo);

		    // 复制文件
            string newBucketName = "demobkt"; // 目标空间，必须是创建过的空间名，可以和源空间名一样
            string newFileName2 = "floder/000000.png"; // 复制后的文件名，若复制后的文件夹不存在，默认创建；若复制后的文件存在，默认覆盖
		    resultInfo = copyFile(bucketName, newFileName, newBucketName, newFileName2);
		    Console.WriteLine("复制文件的返回结果" + resultInfo);

		    // 复制文件夹
            string newFolderName2 = "folder1"; // 复制后的文件夹名，若复制后的文件夹不存在，默认创建；若复制后的文件夹存在，默认合并
		    resultInfo = copyFolder(bucketName, newFolderName, newBucketName, newFolderName2);
		    Console.WriteLine("复制文件夹的返回结果" + resultInfo);
            Console.ReadLine();
        }

        /// <summary>
        /// 获取操作密钥token
        /// </summary>
        /// <returns></returns>
        private static string getToken()
        {
            Object parameter = "";
            parameter = new
            {
                voucher = voucher,
                accessKey = accessKey,
                secretKey = secretKey,
                resource = resource
            };
            string url = api + getTokenMethod;
            string resultString = HttpPost(url, JsonConvert.SerializeObject(parameter), null, null);
            ResultInfo resultInfo = GetResultInfo<ResultInfo>(resultString);
            if (resultInfo != null && resultInfo.Code == 0)
            {
                return resultInfo.Message.ToString().Split(':')[1];
            }
            return "";
        }

        /// <summary>
        /// 上传文件
        /// </summary>
        /// <returns></returns>
        private static string uploadFile(string bucketName, string localFile, string fileName)
        {
            FileStream sfile = new FileStream(localFile, FileMode.Open);//获取流文件
            byte[] bytes = Encoding.GetEncoding("UTF-8").GetBytes(fileName);
            string upfileName = Convert.ToBase64String(bytes);
            Dictionary<string, string> headers = new Dictionary<string, string>();
            headers.Add("resource", resource);
            headers.Add("token", token);
            headers.Add("bucketName", bucketName);
            headers.Add("fileName", upfileName);
            headers.Add("length", sfile.Length + "");
            return HttpPost(api + uploadFileMethod, null, sfile, headers);
        }


        /// <summary>
        /// 获取文件访问链接
        /// </summary>
        /// <returns></returns>
        private static string getFileUrl(string bucketName, string fileName, int minutes)
        {
            Object parameter = "";
            parameter = new
            {
                resource = resource,
                token = token,
                bucketName = bucketName,
                fileName = fileName,
                minutes = minutes,
            };
            return HttpPost(api + getFileUrlMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 删除文件
        /// </summary>
        /// <returns></returns>
        private static string delFile(string bucketName, string fileName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                fileName = fileName
            };
            return HttpPost(api + delFileMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 创建文件夹
        /// </summary>
        /// <returns></returns>
        private static string createFolder(string bucketName, string folderName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                folderName = folderName
            };
            return HttpPost(api + createFolderMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 删除文件夹
        /// </summary>
        /// <returns></returns>
        private static string delFolder(string bucketName, string folderName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                folderName = folderName
            };
            return HttpPost(api + deleteFolderMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 获取当前目录下子目录及文件
        /// </summary>
        /// <returns></returns>
        private static string getSubFoldersAndFiles(string bucketName, string folderName, bool isGetFile)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                folderName = folderName,
                isGetFile = isGetFile
            };
            return HttpPost(api + getsSubFolderAndFilesMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 重命名文件
        /// </summary>
        /// <returns></returns>
        private static string renameFile(string bucketName, string oldFileName, string newFileName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                oldFileName = oldFileName,
                newFileName = newFileName
            };
            return HttpPost(api + renameFileMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 重命名文件夹
        /// </summary>
        /// <returns></returns>
        private static string renameFolder(string bucketName, string oldFolderName, string newFolderName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                bucketName = bucketName,
                oldFolderName = oldFolderName,
                newFolderName = newFolderName
            };
            return HttpPost(api + renameFolderMethod, JsonConvert.SerializeObject(parameter), null, null);
        }
       
        /// <summary>
        /// 复制文件
        /// </summary>
        /// <returns></returns>
        private static string copyFile(string oldBucketName, string oldFileName, string newBucketName, string newFileName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                oldBucketName = oldBucketName,
                oldFileName = oldFileName,
                newBucketName = newBucketName,
                newFileName = newFileName
            };
            return HttpPost(api + copyFileMethod, JsonConvert.SerializeObject(parameter), null, null);
        }

        /// <summary>
        /// 复制文件夹
        /// </summary>
        /// <returns></returns>
        private static string copyFolder(string oldBucketName, string oldFolderName, string newBucketName, string newFolderName)
        {
            Object parameter = "";
            parameter = new
            {
                token = token,
                resource = resource,
                oldBucketName = oldBucketName,
                oldFolderName = oldFolderName,
                newBucketName = newBucketName,
                newFolderName = newFolderName
            };
            return HttpPost(api + copyFolderMethod, JsonConvert.SerializeObject(parameter), null, null);
        }


    

        private static string HttpPost(String url, String content, Stream input, Dictionary<string, string> hander)
        {
            var httpRequest = HttpWebRequest.CreateHttp(url);
            httpRequest.Method = "POST";
            httpRequest.Timeout = 30000;
            httpRequest.KeepAlive = true;
            httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko";
            httpRequest.ContentType = "application/json;charset=UTF-8";

            if (content != null)
            {
                byte[] bytes = System.Text.Encoding.UTF8.GetBytes(content);
                httpRequest.ContentLength = bytes.Length;
                Stream stream = httpRequest.GetRequestStream();
                stream.Write(bytes, 0, bytes.Length);
                stream.Close();
            }

            if (hander != null)
            {
                foreach (var item in hander.Keys)
                {
                    httpRequest.Headers[item] = hander[item];
                }
            }

            if (input != null)
            {
                byte[] bytes = new byte[1024];
                int byteRead = 0;
                Stream stream = httpRequest.GetRequestStream();
                while ((byteRead = input.Read(bytes, 0, bytes.Length)) != 0)
                {
                    stream.Write(bytes, 0, byteRead);
                }
            }

            try
            {
                HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
                using (Stream responseStream = httpResponse.GetResponseStream())
                {
                    using (StreamReader sr = new StreamReader(responseStream, System.Text.Encoding.UTF8))
                    {
                        content = sr.ReadToEnd();
                    }
                }
            }
            catch (Exception e)
            {

                return e.ToString();
            }
            return content;
        }

        #region Common Method

        /// <summary>
        /// 获取返回结果
        /// </summary>
        /// <param name="infoString">API返回信息</param>
        /// <returns>结果对象</returns>
        public static T GetResultInfo<T>(string infoString)
        {
            T result = default(T);
            if (!string.IsNullOrEmpty(infoString.Trim()))
            {
                try
                {
                    result = JsonConvert.DeserializeObject<T>(infoString);
                }
                catch (Exception)
                {
                    //Console.WriteLine(e.ToString());
                }
            }
            return result;
        }
        #endregion
    }
}
